routes/web.php
<?php

use App\Http\Controllers\ApplicantController;
use Illuminate\Foundation\Auth\EmailVerificationRequest;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\FileUploadController;
use App\Http\Controllers\JoblistingController;
use App\Http\Controllers\PostJobController;
use App\Http\Controllers\SubscriptionController;
use App\Http\Middleware\IsEmployer;
use App\Http\Middleware\isPremiumUser;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/',[JoblistingController::class, 'index'])->name('listing.index');
Route::get('/company/{id}',[JoblistingController::class,'company'])->name('company.index');

Route::get('/jobs/{listing:slug}',[JoblistingController::class, 'show'])->name('job.show');
Route::post('/resume/upload',[FileUploadController::class,'store'])->middleware('auth');


Route::get('/email/verify/{id}/{hash}', function (EmailVerificationRequest $request) {
   $request->fulfill();

   return redirect('/login');
})->middleware(['auth', 'signed'])->name('verification.verify');

Route::get('/register/seeker',[UserController::class,'createSeeker'])->name('create.seeker')->middleware('checkAuth');
Route::get('/register/employer',[UserController::class,'createEmployer'])->name('create.employer')->middleware('checkAuth');
Route::post('/register/seeker',[UserController::class,'storeSeeker'])->name('store.seeker');
Route::post('/register/employer',[UserController::class,'storeEmployer'])->name('store.employer');

Route::get('/login',[UserController::class,'login'])->name('login')->middleware('checkAuth');
Route::post('/login',[UserController::class,'postLogin'])->name('login.post');
Route::post('/logout',[UserController::class,'logout'])->name('logout');

Route::get('user/profile',[UserController::class,'profile'])->name('user.profile')->middleware('auth');
Route::post('user/profile',[UserController::class,'update'])->name('user.update.profile')->middleware('auth');
Route::get('user/profile/seeker',[UserController::class,'seekerProfile'])->name('seeker.profile')->middleware('auth');
Route::post('user/password',[UserController::class,'changePassword'])->name('user.password')->middleware('auth');
Route::post('upload/resume',[UserController::class,'uploadResume'])->name('upload.resume')->middleware('auth');

Route::get('user/job/applied',[UserController::class, 'jobApplied'])->name('job.applied')->middleware(['auth','verified']);

Route::get('/dashboard',[DashboardController::class,'index'])->name('dashboard')->middleware(['verified',isPremiumUser::class]);
Route::get('/verify',[DashboardController::class,'verify'])->name('verification.notice');
Route::get('/resend/verification/email',[DashboardController::class,'resend'])->name('resend.email');

Route::get('/subscribe',[SubscriptionController::class,'subscribe'])->name('subscribe');
Route::get('pay/weekly',[SubscriptionController::class,'initiatePayment'])->name('pay.weekly');
Route::get('pay/monthly',[SubscriptionController::class,'initiatePayment'])->name('pay.monthly');
Route::get('pay/yearly',[SubscriptionController::class,'initiatePayment'])->name('pay.yearly');
Route::get('payment/success',[SubscriptionController::class,'paymentSuccess'])->name('payment.success');
Route::get('payment/cancel',[SubscriptionController::class,'paymentCancel'])->name('payment.cancel');

Route::get('job/create',[PostJobController::class,'create'])->name('job.create');
Route::post('job/store',[PostJobController::class,'store'])->name('job.store');
Route::get('job/{listing}/edit',[PostJobController::class,'edit'])->name('job.edit');
Route::put('job/{id}/update',[PostJobController::class,'update'])->name('job.update');
Route::get('job',[PostJobController::class,'index'])->name('job.index');
Route::delete('job/{id}/delete',[PostJobController::class,'destroy'])->name('job.delete');

Route::get('applicants',[ApplicantController::class,'index'])->name('applicants.index');
Route::get('applicants/{listing:slug}',[ApplicantController::class,'show'])->name('applicants.show');
Route::post('shortlist/{listingId}/{userId}',[ApplicantController::class,'shortlist'])->name('applicants.shortlist');
Route::POST('/applicantion/{listingId}/submit',[ApplicantController::class,'apply'])->name('applicantion.submit');

app/Http/Controllers/ApplicantController.php
<?php

namespace App\Http\Controllers;

use App\Mail\ShortlistMail;
use App\Models\Listing;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;

class ApplicantController extends Controller
{
    public function index(){
        $listings= Listing::latest()->withCount('users')->where('user_id',auth()->user()->id)->get();
        return view('applicants.index',compact('listings'));
        // dd($listings);
        // $records=DB::table('listing_user')->whereIn('listing_id',$listings->pluck('id'))->get();
    // /    dd($records);
    }
    public function show(Listing $listing)
    {
        $this->authorize('view',$listing);
        $listings= Listing::with('users')->where('slug',$listing->slug)->first();
        return view('applicants.show',compact('listings'));
    }
    public function shortlist($listingId,$userId){
        $listing=Listing::find($listingId);
        $user= User::find($userId);
        if($listing){
            $listing->users()->updateExistingPivot($userId,['shortlisted'=>true]);
            Mail::to($user->email)->queue(new ShortlistMail($user->name,$listing->title));

            return back()->with('success','User is shortlisted successfully');
        }
        return back();
    }

    public function apply($listingId)
    {
        $user= auth()->user();
        // $user->listings()->syncWithoutDetaching($listingId);
        $user->listings()->attach($listingId);
        return back()->with('success','Your application was success');
    }
}

resources/views/applicants/index.blade.php
@extends('layouts.admin.main')

@section('content')

<div class="container mt-5">
    <div class="row justify-content-center">
            <div class="card mb-4">
                  <div class="card-header">
                    <i class="fas fa-table me-1"></i>
                    Your Jobs
                    </div>
                <div class="card-body">
                    <table id="datatablesSimple">
                        <thead>
                            <tr>
                                <th>Title</th>
                                <th>Created on</th>
                                <th>Edit</th>
                                <th>Delete</th>         
                                <th>Delete</th>         
                            </tr>
                        </thead>
                        <tfoot>
                            <tr>
                                <th>Title</th>
                                <th>Title</th>
                                <th>Created on</th>
                                <th>View Job</th>
                                <th>View applicants</th>
                            </tr> 
                        </tfoot>
                        <tbody>
                            @foreach ($listings as $listing)
                                <tr>
                                    <td>{{$listing->title}} </td>
                                    <td>{{$listing->created_at->format('Y-m-d')}} </td>
                                    <td>{{$listing->users_count}} </td>
                                    <td> View </td>
                                    <td> <a href="{{route('applicants.show',$listing->slug )}}">View</a> </td>
                                </tr>
                                <!-- Modal -->
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
    </div>
</div>
@endsection

resources/views/applicants/show.blade.php
@extends('layouts.admin.main')
@section('content')
    
<div class="container mt-5">    
    <div class="row">
        <div class="col-md-8 mt-5">
            <h1> {{$listings->title}} </h1>            
            @if(Session::has('success'))
                <div class="alert-success">
                    {{Session::get('success')}}
                </div>
            @endif
        </div>
        @foreach($listings->users as $user)
            <div class="card mt-5 {{$user->pivot->shortlisted ? 'card-bg' :''}} ">
                <div class="row g-0">
                    <div class="col-auto">
                        @if ($user->profile_pic)
                        <img src="{{Storage::url($user->profile_pic)}}"class="rounded-circle" style="width: 150px" alt="">
                        @else
                        <img src="https::/placehld.co/400" class="rounded-circle" style="width: 150px"  alt="Profile picture">
                        @endif
                    </div>
                    <div class="col">
                        <div class="card-body">
                            <p class="fw-bold"> {{$user->name}} </p>
                            <p class="card-text"> {{$user->email}} </p>
                            <p class="card-text"> Applied on: {{$user->pivot->created_at}} </p>
                        </div>
                    </div>
                    <div class="col-auto align-self-center">
                        <form action="{{route('applicants.shortlist',[$listings->id,$user->id])}}" method="POST">
                            @csrf
                            <a href="{{Storage::url($user->resume)}}" class="btn btn-primary" target="_blank">Download Resume</a>
                            <button type="submit" class="{{$user->pivot->shortlisted ? 'btn btn-success' : 'btn-dark btn'}}">
                                {{$user->pivot->shortlisted ? 'Shortlisted' : 'shortlist'}}
                            </button>
                        </form>
                    </div>
                    
                </div>
            </div>
        
        @endforeach
    </div>
</div>
<style>
    .card-bg{
        background-color: rgb(28, 250, 61)
    }
</style>
@endsection